//+------------------------------------------------------------------+
//|                                  TickAbsoluteStrengh_v1 600+.mq4 |
//|                                Copyright  2015, TrendLaboratory |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                   E-mail: igorad2003@yahoo.co.uk |
//+------------------------------------------------------------------+
#property copyright "Copyright  2015, TrendLaboratory"
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"


#property indicator_separate_window
#property indicator_buffers   6
#property indicator_color1    DeepSkyBlue
#property indicator_width1    2 
#property indicator_color2    Tomato
#property indicator_width2    2
#property indicator_color3    SkyBlue
#property indicator_width3    1
#property indicator_style3    2
#property indicator_color4    Coral
#property indicator_width4    1
#property indicator_style4    2 
#property indicator_color5    LightGray
#property indicator_width5    1
#property indicator_style5    4 
#property indicator_color6    LightGray
#property indicator_width6    1 
#property indicator_style6    4

//---- input parameters


extern int     TicksNumber          =    15;    // TimeFrame in ticks
extern int     SecsNumber           =     0;    // TimeFrame in secs
extern int     BarsNumber           =   500;    // Number of bars   

extern string  abssets              = "--- Absolute Strength ---";
extern int     MathMode             =     0;    // Math method: 0-RSI;1-Stoch;2-DMI;3-MACD 
extern int     Price                =     0;    // Price = 0...6
extern int     Length               =    14;    // Period of evaluation
extern int     PreSmooth            =     1;    // Period of PreSmoothing
extern int     Smooth               =     5;    // Period of smoothing
extern int     Signal               =     5;    // Period of Signal Line
extern int     MA_Method            =     1;    // See list above
extern int     LevelsMode           =     1;    // Levels Mode: 0-Standard OverBought/OverSold 
                                                //              1-StdDev Bands
                                                //              2-High/Low Channel
extern double  StrengthLevel        =    80;    // Strength Level (ex.70)
extern double  WeaknessLevel        =    20;    // Weakness Level (ex.30)
extern int     LookBackPeriod       =     1;    // LookBack Period for LevelsMode=1,2 
extern double  UpperMultiplier      =     1;    // Upper Band Multiplier for LevelsMode=1 
extern double  LowerMultiplier      =     1;    // Lower Band Multiplier for LevelsMode=1 


//---- buffers 
double Bulls[];
double Bears[];
double sigBulls[];
double sigBears[];
double strength[];
double weakness[];
double lbulls[];
double lbears[];
double bulls[];
double bears[];

double tClose[], Hi[], Lo[], tOpen[], aprice[], loprice[], tVolume[];

int      masize, prevbar[8], maxlen;
double   tmp[][8][2], ma[8][3], mMA[2], mLo[2], HiArray[], LoArray[]; 
int      window, tickCounter, barCounter, nextSecs, prevasbar;
double   _point;

string   IndicatorName, short_name, math_name, maname, zone_name, t;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
//---- indicators
   IndicatorBuffers(17);
   SetIndexBuffer( 0,   Bulls); SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer( 1,   Bears); SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer( 2,sigBulls); SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer( 3,sigBears); SetIndexStyle(3,DRAW_LINE);
   SetIndexBuffer( 4,strength); SetIndexStyle(4,DRAW_LINE);
   SetIndexBuffer( 5,weakness); SetIndexStyle(5,DRAW_LINE);
   SetIndexBuffer( 6,  lbulls);
   SetIndexBuffer( 7,  lbears);   
   SetIndexBuffer( 8,   bulls);
   SetIndexBuffer( 9,   bears);      
   SetIndexBuffer(10,  tClose);
   SetIndexBuffer(11,      Hi); 
   SetIndexBuffer(12,      Lo);
   SetIndexBuffer(13,   tOpen); 
   SetIndexBuffer(14,  aprice);
   SetIndexBuffer(15, loprice);
   SetIndexBuffer(16, tVolume);
   
   IndicatorDigits(Digits + 2);
   
   if(TicksNumber > 0) t = TicksNumber +" Ticks ";
   if(SecsNumber  > 0) t = SecsNumber  +" Secs " ;
      
   switch(MathMode)
   {
   case 0 : math_name = "RSI"  ; break;
   case 1 : math_name = "Stoch"; break;
   case 2 : math_name = "DMI"  ; break;
   case 3 : math_name = "MACD" ; break;
   }
     
   
   maname = averageName(MA_Method, masize);
   
   IndicatorName = WindowExpertName(); 
   
   short_name =  "[" + t + "]("+ math_name + "," + Price + "," + Length + "," + PreSmooth + "," + Smooth + "," + Signal + "," + maname+")";// + "," + LevelsMode+")";
   
   IndicatorShortName(IndicatorName + short_name);
   
   
   SetIndexLabel(0,"Bulls");
   SetIndexLabel(1,"Bears");
   SetIndexLabel(2,"Signal Bulls");
   SetIndexLabel(3,"Signal Bears");     
   SetIndexLabel(4,"Strength Line");
   SetIndexLabel(5,"Weakness Line");
 
   SetIndexEmptyValue( 4,0.0);
   SetIndexEmptyValue( 5,0.0);
   
   
   if(SecsNumber > 0) nextSecs = TimeCurrent() - MathMod(TimeCurrent(),SecsNumber) + SecsNumber;  
  
   ArrayResize(tmp    ,        masize);
   ArrayResize(HiArray,LookBackPeriod);
   ArrayResize(LoArray,LookBackPeriod);
   maxlen   = MathMax(LookBackPeriod,MathMax(Signal,MathMax(Length,MathMax(PreSmooth,Smooth)))); 
   _point   = Point*MathPow(10,Digits%2);
//----
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
   Comment("");
   return(0);
}



//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int i,cnt_bars = IndicatorCounted();
   
   window = WindowFind(short_name);
   
   if(cnt_bars < 0) return(0);
   if(cnt_bars < 1) 
   {
      for(i=Bars-1;i>=0;i--)
      {
      Bulls[i]    = EMPTY_VALUE; 
      Bears[i]    = EMPTY_VALUE; 
      sigBulls[i] = EMPTY_VALUE; 
      sigBears[i] = EMPTY_VALUE;
      strength[i] = 0; 
      weakness[i] = 0;
      }
   }
 
   
   tickCounter++;
   
   bool tcond = false;   
   if(TicksNumber > 0 && SecsNumber == 0) tcond = tickCounter > 0 && tickCounter % TicksNumber == 0;
   if(TicksNumber == 0 && SecsNumber > 0) tcond = TimeCurrent() >= nextSecs;
   
   if(tcond) 
   {
   barCounter ++; 
   
   if(!isNewBar()) ShiftArray(0); 
   tOpen[0]   = Bid;
   tClose[0]  = Bid;
   Hi[0]      = Bid;
   Lo[0]      = Bid; 
   tVolume[0] = Volume[0];
   if(SecsNumber > 0) nextSecs = TimeCurrent() - MathMod(TimeCurrent(),SecsNumber) + SecsNumber;  
   }
   
   if(barCounter > 0)
   {
   if(isNewBar()) ShiftArray(1);
   tClose[0] = Bid;
   Hi[0]     = MathMax(Hi[0],Bid);
   if(Lo[0] > 0) Lo[0] = MathMin(Lo[0],Bid); else Lo[0] = Bid; 
   tVolume[0] += Volume[0];
   }
  
   if(barCounter >= BarsNumber) 
   {
   Bulls[BarsNumber]    = EMPTY_VALUE;
   Bears[BarsNumber]    = EMPTY_VALUE;
   sigBulls[BarsNumber] = EMPTY_VALUE;
   sigBears[BarsNumber] = EMPTY_VALUE;
   weakness[BarsNumber] = 0.0;
   strength[BarsNumber] = 0.0;
   }
        
      if(prevasbar != barCounter) 
      {
      mMA[1]    = mMA[0]; 
      mLo[1]    = mLo[0]; 
      prevasbar = barCounter;
      //Print("bar=",barCounter," bulls=",bulls[1]," lbulls=",lbulls[1]," Bulls=",Bulls[1]);
      }
   
   if(MathMode != 2) aprice[0] = getPrice(Price); else aprice[0] = getPrice(2);;
   
   if(barCounter > PreSmooth + 1)
   {      
   mMA[0] = allAveragesOnArray(0,aprice,PreSmooth,MA_Method,masize,PreSmooth + 2,barCounter);       
      
	   if(barCounter > PreSmooth + Length + 1)
      {
	      if (MathMode == 0)
         {
         bulls[0] = 0.5*(MathAbs(mMA[0] - mMA[1]) + (mMA[0] - mMA[1]));
         bears[0] = 0.5*(MathAbs(mMA[0] - mMA[1]) - (mMA[0] - mMA[1]));
         }
         else  
         if (MathMode == 1)
         {
         double up = TickHighest(Length);
         double dn = TickLowest (Length);
         bulls[0] = mMA[0] - dn;
         bears[0] = up - mMA[0];
         }
         else   
         if (MathMode == 2)
         {
         loprice[0] = getPrice(3);
         mLo[0] = allAveragesOnArray(1,loprice,PreSmooth,MA_Method,masize,PreSmooth + Length + 2,barCounter);          
               
         bulls[0] = MathMax(0,0.5*(MathAbs(mMA[0] - mMA[1]) + (mMA[0] - mMA[1])));
         bears[0] = MathMax(0,0.5*(MathAbs(mLo[1] - mLo[0]) + (mLo[1] - mLo[0])));
      
            if(bulls[0] > bears[0]) bears[0] = 0;
            else 
            if(bulls[0] < bears[0]) bulls[0] = 0;
            else {bulls[0] = 0; bears[0] = 0;}
         }
         else
         if(MathMode == 3)
         {
         double slow = allAveragesOnArray(1,aprice,Length,MA_Method,masize,PreSmooth + Length + 2,barCounter); 
         bulls[0] = 0.5*(MathAbs(mMA[0] - slow) + (mMA[0] - slow));
         bears[0] = 0.5*(MathAbs(mMA[0] - slow) - (mMA[0] - slow));
         }
         
      if(MathMode == 1 || MathMode == 3) int len = 1; else len = Length; 
   
      lbulls[0] = allAveragesOnArray(2,bulls,len,MA_Method,masize,PreSmooth + Length + 2,barCounter);
      lbears[0] = allAveragesOnArray(3,bears,len,MA_Method,masize,PreSmooth + Length + 2,barCounter);
   
      
         if(barCounter > PreSmooth + Length + Smooth + 1)
         {   
         Bulls[0]  = allAveragesOnArray(4,lbulls,Smooth,MA_Method,masize,PreSmooth + Length + Smooth + 2,barCounter)/_point;      
         Bears[0]  = allAveragesOnArray(5,lbears,Smooth,MA_Method,masize,PreSmooth + Length + Smooth + 2,barCounter)/_point;  
                  
            if(Signal > 0)
            {   
               if(barCounter > PreSmooth + Length + Smooth + Signal + 1)
               {   
                  if(Signal > 1)
                  {
                  sigBulls[0] = allAveragesOnArray(6,Bulls,Signal,MA_Method,masize,PreSmooth + Length + Smooth + Signal + 2,barCounter);      
                  sigBears[0] = allAveragesOnArray(7,Bears,Signal,MA_Method,masize,PreSmooth + Length + Smooth + Signal + 2,barCounter);        
                  }
                  else
                  {
                  sigBulls[0] = Bulls[1];
                  sigBears[0] = Bears[1];
                  }
               }
            } else {sigBulls[0] = EMPTY_VALUE; sigBears[0] = EMPTY_VALUE;}
      
            if(LevelsMode == 0)
            {
            if(StrengthLevel > 0) strength[0] = StrengthLevel/100*(Bulls[0] + Bears[0]);
            if(WeaknessLevel > 0) weakness[0] = WeaknessLevel/100*(Bulls[0] + Bears[0]);
            }
            else
            if(LevelsMode == 1 && barCounter > PreSmooth + Length + Smooth + LookBackPeriod + 1)
            {
               for(int j=0;j<LookBackPeriod;j++)
               { 
               HiArray[j] = MathMax(Bulls[j],Bears[j]);  
               LoArray[j] = MathMin(Bulls[j],Bears[j]); 
               }      
         
            if(UpperMultiplier > 0) strength[0] = SMAOnArray(HiArray,LookBackPeriod,0) + UpperMultiplier*stdDev(HiArray,LookBackPeriod); 
            if(LowerMultiplier > 0) weakness[0] = SMAOnArray(LoArray,LookBackPeriod,0) - LowerMultiplier*stdDev(LoArray,LookBackPeriod);
            }
            else
            if(LevelsMode == 2 && barCounter > PreSmooth + Length + Smooth + LookBackPeriod + 1)
            {
               for(j = 0;j<LookBackPeriod;j++)
               { 
               HiArray[j] = MathMax(Bulls[j],Bears[j]);  
               LoArray[j] = MathMin(Bulls[j],Bears[j]); 
               }   
                  
            double upPivot = getPivots(2,HiArray,LookBackPeriod,0);
            double dnPivot = getPivots(3,LoArray,LookBackPeriod,0);
     
            strength[0] = upPivot - (upPivot - dnPivot)*(1 - StrengthLevel/100);
            weakness[0] = dnPivot + (upPivot - dnPivot)*WeaknessLevel/100;
            }
         }
      }
   }
  
//----
   return(0);
}
//+------------------------------------------------------------------+
double getPrice(int mode)
{
   switch(mode)
   {
   case  0: return(tClose[0]) ; break;  
   case  1: return(tOpen[0])  ; break; 
   case  2: return(Hi[0])     ; break; 
   case  3: return(Lo[0])     ; break; 
   case  4: return((Hi[0] + Lo[0])/2)              ; break; 
   case  5: return((Hi[0] + Lo[0] + tClose[0])/3)  ; break;
   case  6: return((Hi[0] + Lo[0] + 2*tClose[0])/4); break;
   default: return(tClose[0]) ; break;
   }
}

double TickLowest(int per)
{
   double lowest = 1000000;
   for(int i = 0;i < per;i++) lowest = MathMin(lowest,Lo[i]);
   return(lowest);
}                

double TickHighest(int per)
{
   double highest = 0;
   for(int i = 0;i < per;i++) highest = MathMax(highest,Hi[i]);
   return(highest);
} 


void ShiftArray(int mode)
{
   if(mode == 0)
   {
      for(int cnt=barCounter;cnt>=0;cnt--)
      {
      Hi [cnt]       = Hi[cnt-1];
      Lo [cnt]       = Lo[cnt-1];
      tOpen[cnt]     = tOpen[cnt-1];
      tClose[cnt]    = tClose[cnt-1];
      aprice[cnt]    = aprice[cnt-1];
      loprice[cnt]   = loprice[cnt-1];
      Bulls[cnt]     = Bulls[cnt-1];
      Bears[cnt]     = Bears[cnt-1];
      sigBulls[cnt]  = sigBulls[cnt-1];
      sigBears[cnt]  = sigBears[cnt-1];
      weakness[cnt]  = weakness[cnt-1];
      strength[cnt]  = strength[cnt-1];
      bulls[cnt]     = bulls[cnt-1];
      bears[cnt]     = bears[cnt-1];
      lbulls[cnt]    = lbulls[cnt-1];
      lbears[cnt]    = lbears[cnt-1];
      tVolume[cnt]   = tVolume[cnt-1];
      }
   }
   else
   {
      for(cnt=1;cnt<=barCounter;cnt++)
      {
      Hi [cnt-1]       = Hi[cnt];
      Lo [cnt-1]       = Lo[cnt];
      tOpen[cnt-1]     = tOpen[cnt];
      tClose[cnt-1]    = tClose[cnt];
      aprice[cnt-1]    = aprice[cnt];
      loprice[cnt-1]   = loprice[cnt];
      Bulls[cnt-1]     = Bulls[cnt];
      Bears[cnt-1]     = Bears[cnt];
      sigBulls[cnt-1]  = sigBulls[cnt];
      sigBears[cnt-1]  = sigBears[cnt];
      weakness[cnt-1]  = weakness[cnt];
      strength[cnt-1]  = strength[cnt];
      bulls[cnt-1]     = bulls[cnt];
      bears[cnt-1]     = bears[cnt];
      lbulls[cnt-1]    = lbulls[cnt];
      lbears[cnt-1]    = lbears[cnt];
      tVolume[cnt-1]   = tVolume[cnt];
      
      Hi[cnt]        = 0.0;
      Lo[cnt]        = 0.0;
      tOpen[cnt]     = 0.0;
      tClose[cnt]    = 0.0;
      aprice[cnt]    = 0.0;
      loprice[cnt]   = 0.0; 
      Bulls[cnt]     = 0.0;
      Bears[cnt]     = 0.0;
      sigBulls[cnt]  = 0.0;
      sigBears[cnt]  = 0.0;
      weakness[cnt]  = 0.0;
      strength[cnt]  = 0.0;
      bulls[cnt]     = 0.0;
      bears[cnt]     = 0.0;
      lbulls[cnt]    = 0.0;
      lbears[cnt]    = 0.0;
      
      tVolume[cnt]   = 0.0;
      }
   }
}

string averageName(int mode,int& arraysize)
{   
   string ma_name = "";
   
   switch(mode)
   {
   case 1 : ma_name = "EMA"       ; break;
   case 2 : ma_name = "Wilder"    ; break;
   case 3 : ma_name = "LWMA"      ; break;
   case 4 : ma_name = "SineWMA"   ; break;
   case 5 : ma_name = "TriMA"     ; break;
   case 6 : ma_name = "LSMA"      ; break;
   case 7 : ma_name = "SMMA"      ; break;
   case 8 : ma_name = "HMA"       ; break;
   case 9 : ma_name = "ZEMA"      ; break;
   case 10: ma_name = "DEMA"      ; arraysize = 2; break;
   case 11: ma_name = "T3 basic"  ; arraysize = 6; break;
   case 12: ma_name = "ITrend"    ; break;
   case 13: ma_name = "Median"    ; break;
   case 14: ma_name = "GeoMean"   ; break;
   case 15: ma_name = "REMA"      ; break;
   case 16: ma_name = "ILRS"      ; break;
   case 17: ma_name = "IE/2"      ; break;
   case 18: ma_name = "TriMA_g"   ; break;
   case 19: ma_name = "VWMA"      ; break;
   case 20: ma_name = "JSmooth"   ; arraysize = 5; break;
   case 21: ma_name = "SMA_eq"    ; break;
   case 22: ma_name = "ALMA"      ; break;
   case 23: ma_name = "TEMA"      ; arraysize = 4; break;
   case 24: ma_name = "T3"        ; arraysize = 6; break;
   case 25: ma_name = "Laguerre"  ; arraysize = 4; break;
   default: ma_name = "SMA"       ;
   }
   
   return(ma_name);
   
}


double allAveragesOnArray(int index,double& price[],int period,int mode,int arraysize,int startbar,int bar)
{
   double MA[3];  
        
    if(prevbar[index] != barCounter)
    {
    ma[index][2]  = ma[index][1]; 
    ma[index][1]  = ma[index][0]; 
    for(int i=0;i<arraysize;i++) tmp[i][index][1] = tmp[i][index][0];
    prevbar[index] = barCounter; 
    }
   
   for(i=0;i<3;i++) MA[i] = ma[index][i];   
   
   switch(mode)
   {
   case 1 : ma[index][0] = EMAOnArray(price[0],ma[index][1],period,startbar,bar);      break;
   case 2 : ma[index][0] = WilderOnArray(price[0],ma[index][1],period,startbar,bar);   break;  
   case 3 : ma[index][0] = LWMAOnArray(price,period,0);                                break;
   case 4 : ma[index][0] = SineWMAOnArray(price,period,bar);                           break;
   case 5 : ma[index][0] = TriMAOnArray(price,period,bar);                             break;
   case 6 : ma[index][0] = LSMAOnArray(price,period,bar);                              break;
   case 7 : ma[index][0] = SMMAOnArray(price,ma[index][1],period,startbar,bar);        break;
   case 8 : ma[index][0] = HMAOnArray(price,period,bar);                               break;
   case 9 : ma[index][0] = ZeroLagEMAOnArray(price,ma[index][1],period,startbar,bar);  break;
   case 10: ma[index][0] = DEMAOnArray(index,0,price[0],period,1,startbar,bar);        break;
   case 11: ma[index][0] = T3_basicOnArray(index,0,price[0],period,0.7,startbar,bar);  break;
   case 12: ma[index][0] = ITrendOnArray(price,MA,period,startbar,bar);                break;
   case 13: ma[index][0] = MedianOnArray(price,period,bar);                            break;
   case 14: ma[index][0] = GeoMeanOnArray(price,period,startbar,bar);                  break;
   case 15: ma[index][0] = REMAOnArray(price[0],MA,period,0.5,bar);                    break;
   case 16: ma[index][0] = ILRSOnArray(price,period,bar);                              break;
   case 17: ma[index][0] = IE2OnArray(price,period,bar);                               break;
   case 18: ma[index][0] = TriMA_genOnArray(price,period,bar);                         break;
   case 19: ma[index][0] = VWMAOnArray(price,period,bar);                              break;
   case 20: ma[index][0] = JSmoothOnArray(index,0,price[0],period,1,startbar,bar);     break;
   case 21: ma[index][0] = SMA_eqOnArray(price,ma[index][1],period,startbar,bar);      break;
   case 22: ma[index][0] = ALMAOnArray(price,period,0.85,8,bar);                       break;
   case 23: ma[index][0] = TEMAOnArray(index,price[0],period,1,startbar,bar);          break;
   case 24: ma[index][0] = T3OnArray(index,0,price[0],period,0.7,startbar,bar);        break;
   case 25: ma[index][0] = LaguerreOnArray(index,price[0],period,4,bar);               break;
   default: ma[index][0] = SMAOnArray(price,period,0);                                 break;
   }
   
   return(ma[index][0]);
}


double SMAOnArray(double& price[],int per,int bar)
{
   double Sum = 0;
   for(int i=0;i<per;i++) Sum += price[bar+i];
   
   return(Sum/per);
}
                           
// MA_Method=1: EMA - Exponential Moving Average
double EMAOnArray(double price,double prev,int per,int startbar,int bar)
{
   if(bar == startbar || per == 1) return(price);
   else 
   double ema = prev + 2.0/(1 + per)*(price - prev); 
   
   return(ema);
}

// MA_Method=2: Wilder - Wilder Exponential Moving Average
double WilderOnArray(double price,double prev,int per,int startbar,int bar)
{
   if(bar == startbar || per == 1) return(price);
   else 
   double wilder = prev + (price - prev)/per; 
   
   return(wilder);
}

// MA_Method=3: LWMA - Linear Weighted Moving Average 
double LWMAOnArray(double& price[],int per,int bar)
{
   if(per == 1) return(price[0]);
   double Sum = 0, Weight = 0;
   
      for(int i=0;i<per;i++)
      { 
      Weight += (per - i);
      Sum    += price[bar+i]*(per - i);
      }
   if(Weight>0) double lwma = Sum/Weight; else lwma = 0; 
   
   return(lwma);
}

 
// MA_Method=4: SineWMA - Sine Weighted Moving Average
double SineWMAOnArray(double& price[],int per,int bar)
{
   if(per == 1) return(price[0]);
   double pi = 3.1415926535, Sum = 0, Weight = 0;
  
      for(int i=0;i<per;i++)
      { 
      Weight += MathSin(pi*(i + 1)/(per + 1));
      Sum    += price[i]*MathSin(pi*(i + 1)/(per + 1)); 
      }
   if(Weight>0) double swma = Sum/Weight; else swma = 0; 
   
   return(swma);
}

// MA_Method=5: TriMA - Triangular Moving Average
double TriMAOnArray(double& price[],int per,int bar)
{
   if(per == 1) return(price[0]);
   double sma, sum = 0;
   int len = MathCeil((per + 1)*0.5);
   
   for(int i=0;i<len;i++) 
   {
   sma  = SMAOnArray(price,len,i);
   sum += sma;
   } 
   double trima = sum/len;
   
   return(trima);
}

// MA_Method=6: LSMA - Least Square Moving Average (or EPMA, Linear Regression Line)
double LSMAOnArray(double& price[],int per,int bar)
{   
   if(per == 1) return(price[0]);
   double Sum = 0;
   for(int i=per;i>=1;i--) Sum += (i - (per + 1)/3.0)*price[per-i];
   double lsma = Sum*6/(per*(per + 1));
   return(lsma);
}

// MA_Method=7: SMMA - Smoothed Moving Average
double SMMAOnArray(double& price[],double prev,int per,int startbar,int bar)
{
   
   if(per == 1) return(price[0]);
   
   if(bar == startbar) double smma = SMAOnArray(price,per,0);
   else 
   if(bar > startbar)
   {
   double Sum = 0;
   for(int i = 0;i < per;i++) Sum += price[i+1];
   smma = (Sum - prev + price[0])/per;
   }
   
   return(smma);
}
                           
// MA_Method=8: HMA - Hull Moving Average by Alan Hull
double HMAOnArray(double& price[],int per,int bar)
{
   double _tmp[];
   int len = MathSqrt(per);
   
   ArrayResize(_tmp,len);
   
   if(bar == per || per == 1) double hma = price[0]; 
   else
   if(bar > per)
   {
   for(int i=0;i<len;i++) _tmp[i] = 2*LWMAOnArray(price,per*0.5,i) - LWMAOnArray(price,per,i);  
   hma = LWMAOnArray(_tmp,len,0); 
   }  

   return(hma);
}

// MA_Method=9: ZeroLagEMA - Zero-Lag Exponential Moving Average
double ZeroLagEMAOnArray(double& price[],double prev,int per,int startbar,int bar)
{
   if(per == 1) return(price[0]);
   
   double alfa = 2.0/(1 + per); 
   int lag     = 0.5*(per - 1); 
   
   if(bar == MathMax(lag,startbar)) double zema = price[0];
   else 
   zema = alfa*(2*price[0] - price[lag]) + (1 - alfa)*prev;
   
   return(zema);
}

// MA_Method=10: DEMA - Double Exponential Moving Average by Patrick Mulloy
double DEMAOnArray(int index,int num,double price,double per,double v,int startbar,int bar)
{
   if(per == 1) return(price);
   
   double alpha = 2.0/(1 + per);
   
   if(bar == startbar) {double dema = price; tmp[num][index][0] = dema; tmp[num+1][index][0] = dema;}
   else 
   if(bar >  startbar) 
   {
   tmp[num  ][index][0] = tmp[num  ][index][1] + alpha*(price              - tmp[num  ][index][1]); 
   tmp[num+1][index][0] = tmp[num+1][index][1] + alpha*(tmp[num][index][0] - tmp[num+1][index][1]); 
   dema                 = tmp[num  ][index][0]*(1+v) - tmp[num+1][index][0]*v;
   }
   
   return(dema);
}

// MA_Method=11: T3 by T.Tillson
double T3_basicOnArray(int index,int num,double price,int per,double v,int startbar,int bar)
{
   if(per == 1) return(price);
   
   double dema1, dema2;
   
   if(bar == startbar) 
   {
   double T3 = price; 
   for(int k=0;k<6;k++) tmp[num+k][index][0] = price;
   }
   else 
   if(bar > startbar) 
   {
   dema1 = DEMAOnArray(index,num  ,price,per,v,startbar,bar); 
   dema2 = DEMAOnArray(index,num+2,dema1,per,v,startbar,bar); 
   T3    = DEMAOnArray(index,num+4,dema2,per,v,startbar,bar);
   }
   
   return(T3);
}

// MA_Method=12: ITrend - Instantaneous Trendline by J.Ehlers
double ITrendOnArray(double& price[],double& array[],int per,int startbar,int bar)
{
   if(per == 1) return(price[0]);
   
   double alfa = 2.0/(per + 1);
   
   if(bar == MathMax(7,startbar)) double it = (price[0] + 2*price[1] + price[2])/4;
   else it = (alfa - 0.25*alfa*alfa)*price[0] + 0.5*alfa*alfa*price[1] - (alfa - 0.75*alfa*alfa)*price[2] + 2*(1-alfa)*array[1] - (1-alfa)*(1-alfa)*array[2];
   
   return(it);
}
// MA_Method=13: Median - Moving Median
double MedianOnArray(double& price[],int per,int bar)
{
   if(per == 1) return(price[0]);
   
   double array[];
   ArrayResize(array,per);
   
   for(int i = 0; i < per;i++) array[i] = price[i];
   ArraySort(array,WHOLE_ARRAY,0,MODE_DESCEND);
   
   int num = MathRound((per - 1)*0.5); 
   if(MathMod(per,2.0) > 0) double median = array[num]; else median = 0.5*(array[num] + array[num+1]);
    
   return(median); 
}
// MA_Method=14: GeoMean - Geometric Mean
double GeoMeanOnArray(double& price[],int per,int startbar,int bar)
{
   if(per == 1) return(price[0]);
   
   if(bar > startbar)
   { 
   double gmean = 0; 
      for(int i=0;i<per;i++) 
      {
      if(price[i] == 0) price[i] = 0.0000001;
      gmean *= MathPow(price[i],1.0/per); 
      }
   }
   
   return(gmean);
}
// MA_Method=15: REMA - Regularized EMA by Chris Satchwell 
double REMAOnArray(double price,double& array[],int per,double lambda,int bar)
{
   double alpha =  2.0/(per + 1);
   if(bar < 3) double rema = price;
   else 
   rema = (array[1]*(1+2*lambda) + alpha*(price - array[1]) - lambda*array[2])/(1+lambda); 
   
   return(rema);
}
// MA_Method=16: ILRS - Integral of Linear Regression Slope 
double ILRSOnArray(double& price[],int per,int bar)
{
   double sum  = per*(per - 1)*0.5;
   double sum2 = (per - 1)*per*(2*per - 1)/6.0;
     
   double sum1 = 0;
   double sumy = 0;
      for(int i=0;i<per;i++)
      { 
      sum1 += i*price[i];
      sumy += price[i];
      }
   double num1 = per*sum1 - sum*sumy;
   double num2 = sum*sum - per*sum2;
   
   if(num2 != 0) double slope = num1/num2; else slope = 0; 
   double ilrs = slope + SMAOnArray(price,per,0);
   
   return(ilrs);
}
// MA_Method=17: IE/2 - Combination of LSMA and ILRS 
double IE2OnArray(double& price[],int per,int bar)
{
   double ie = 0.5*(ILRSOnArray(price,per,bar) + LSMAOnArray(price,per,bar));
      
   return(ie); 
}

// MA_Method=18: TriMAgen - Triangular Moving Average Generalized by J.Ehlers
double TriMA_genOnArray(double& price[],int per,int bar)
{
   if(per == 1) return(price[0]);
   
   int len1 = MathFloor((per + 1)*0.5);
   int len2 = MathCeil ((per + 1)*0.5);
   
   double sum = 0;
   
   for(int i=0;i<len2;i++) sum += SMAOnArray(price,len1,i);
   double trimagen = sum/len2;
   
   return(trimagen);
}

// MA_Method=19: VWMA - Volume Weighted Moving Average 
double VWMAOnArray(double& price[],int per,int bar)
{
   if(per == 1) return(price[0]);
   
   double Sum = 0, Weight = 0;
   
      for(int i = 0;i < per;i++)
      { 
      Weight += tVolume[i];
      Sum    += price[i]*tVolume[i];
      }
   
   if(Weight > 0) double vwma = Sum/Weight; else vwma = 0; 
   
   return(vwma);
} 
// MA_Method=20: JSmooth - Smoothing by Mark Jurik
double JSmoothOnArray(int index,int num,double price,int per,double pow,int startbar,int bar)
{
   if(per == 1) return(price);
   
   double beta  = 0.45*(per - 1)/(0.45*(per - 1) + 2);
	double alpha = MathPow(beta,pow);
	
	if(bar == startbar) {tmp[num+4][index][0] = price; tmp[num+0][index][0] = price; tmp[num+2][index][0] = price;}
	else 
   if(bar >  startbar) 
   {
	tmp[num+0][index][0] = (1 - alpha)*price + alpha*tmp[num+0][index][1];
	tmp[num+1][index][0] = (price - tmp[num+0][index][0])*(1 - beta) + beta*tmp[num+1][index][1];
	tmp[num+2][index][0] = tmp[num+0][index][0] + tmp[num+1][index][0];
	tmp[num+3][index][0] = (tmp[num+2][index][0] - tmp[num+4][index][1])*MathPow((1 - alpha),2) + MathPow(alpha,2)*tmp[num+3][index][1];
	tmp[num+4][index][0] = tmp[num+4][index][1] + tmp[num+3][index][0]; 
   }
   return(tmp[num+4][index][0]);
}

// MA_Method=21: SMA_eq     - Simplified SMA
double SMA_eqOnArray(double& price[],double prev,int per,int startbar,int bar)
{
   if(per == 1) return(price[0]);
   
   if(bar == startbar) double sma = SMAOnArray(price,per,0);
   else 
   if(bar >  startbar) sma = (price[0] - price[per])/per + prev; 
   
   return(sma);
}                 
// MA_Method=22: ALMA by Arnaud Legoux / Dimitris Kouzis-Loukas / Anthony Cascino
double ALMAOnArray(double& price[],int per,double offset,double sigma,int bar)
{
   if(per == 1) return(price[0]);
   
   double m = MathFloor(offset*(per - 1));
	double s = per/sigma;
		
	double w, sum = 0, wsum = 0;		
	for(int i=0;i<per;i++) 
	{
	w = MathExp(-((i - m)*(i - m))/(2*s*s));
   wsum += w;
   sum  += price[(per - 1 - i)]*w; 
   }
   
   if(wsum != 0) double alma = sum/wsum; 
   
   return(alma);
}
  
// MA_Method=23: TEMA - Triple Exponential Moving Average by Patrick Mulloy
double TEMAOnArray(int index,double price,int per,double v,int startbar,int bar)
{
   if(per == 1) return(price);
   
   double alpha = 2.0/(per + 1);
	
	if(bar == startbar) {tmp[0][index][0] = price; tmp[1][index][0] = price; tmp[2][index][0] = price;}
	else 
   if(bar >  startbar) 
   {
	tmp[0][index][0] = tmp[0][index][1] + alpha *(price            - tmp[0][index][1]);
	tmp[1][index][0] = tmp[1][index][1] + alpha *(tmp[0][index][0] - tmp[1][index][1]);
	tmp[2][index][0] = tmp[2][index][1] + alpha *(tmp[1][index][0] - tmp[2][index][1]);
	tmp[3][index][0] = tmp[0][index][0] + v*(tmp[0][index][0] + v*(tmp[0][index][0] - tmp[1][index][0]) - tmp[1][index][0] - v*(tmp[1][index][0] - tmp[2][index][0])); 
	}
   
   return(tmp[3][index][0]);
}

// MA_Method=24: T3 by T.Tillson (correct version) 
double T3OnArray(int index,int num,double price,int per,double v,int startbar,int bar)
{
   if(per == 1) return(price);
   
   double len = MathMax((per + 5.0)/3.0 - 1,1), dema1, dema2;
     
   if(bar == startbar) 
   {
   double T3 = price; 
   for(int k=0;k<6;k++) tmp[num+k][index][0] = T3;
   }
   else 
   if(bar > startbar) 
   {
   dema1 = DEMAOnArray(index,num  ,price,len,v,startbar,bar); 
   dema2 = DEMAOnArray(index,num+2,dema1,len,v,startbar,bar); 
   T3    = DEMAOnArray(index,num+4,dema2,len,v,startbar,bar);
   }
      
   return(T3);
}

// MA_Method=25: Laguerre filter by J.Ehlers
double LaguerreOnArray(int index,double price,int per,int order,int bar)
{
   if(per == 1) return(price);
   
   double gamma = 1 - 10.0/(per + 9);
   double aPrice[];
   
   ArrayResize(aPrice,order);
   
   for(int i=0;i<order;i++)
   {
      if(bar <= order) tmp[i][index][0] = price;
      else
      {
         if(i == 0) tmp[i][index][0] = (1 - gamma)*price + gamma*tmp[i][index][1];
         else
         tmp[i][index][0] = -gamma * tmp[i-1][index][0] + tmp[i-1][index][1] + gamma * tmp[i][index][1];
      
      aPrice[i] = tmp[i][index][0];
      }
   }
   double laguerre = TriMA_genOnArray(aPrice,order,0);  

   return(laguerre);
}
               
double stdDev(double& array[],int length)
{
   double avg = 0;
   for (int i=0;i<length;i++) avg += array[i]/length;
        
   double sum = 0;
   for (i=0;i<length;i++) sum += MathPow(array[i] - avg,2);
   return(MathSqrt(sum/length));
}


double getPivots(int type,double& price[],int size,double height)
{
   if(type < 2) int len = 2*MathMax(1,size) + 1; else len = size;
      
   int imax = 0, imin = 0;
   double max = 0, min = 100000000;
       
   for(int i=0;i<len;i++)
   { 
      if((type == 0 || type == 2) && price[i] > max && price[i] < 1000000) {max = price[i]; imax = i;}  
      if((type == 1 || type == 3) && price[i] < min ) {min = price[i]; imin = i;}  
   }
   
   if(type < 2) 
   {
   if(imax == size && max - price[0] > height && max - price[len-1] > height) return(max); 
   if(imin == size && price[0] - min > height && price[len-1] - min > height) return(min);
   }
   else 
   {
   if(type == 2) return(max); 
   if(type == 3) return(min); 
   }
   
   return(0);  
}   

datetime prevnbtime;

bool isNewBar()
{
   bool res = false;
   
   if(Time[0] != prevnbtime)
   {
   res   = true;
   prevnbtime = Time[0];
   }
         
   return(res);
}

